//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//
// OpenGL Sprite class v 1.1
//
// by Christopher Rasmussen, cer@cis.udel.edu
//
// CISC 440/660, September, 2008
// modified April, 2010
//
// copyright 2010
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#ifndef SPRITE_H
#define SPRITE_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <string>
#include <vector>
#include <map>

#include <sys/time.h>

#include <GL/glut.h>

using namespace std;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

struct RGB
{
  int r, g, b;
};

void clear_sprites();
void add_sprite_info(string, int, RGB &);
void finalize_sprites();

// green pixels are transparent by default
unsigned char *read_PPM(const char *, int *, int *, RGB &);

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// display a single static image

class Sprite 
{
public:

  Sprite(int);

  void draw(float, float, float, float, float, float = 1.0, float = 1.0, float = 1.0);
  void draw_sub_sprite(float, float, float, float, float, float, float, float, float, float = 1.0, float = 1.0, float = 1.0);  

  float s, t, sdelta, tdelta;    // bounding rect in texture coordinates
  int texture_number;            // which texture
  int imwidth, imheight;         // "natural" dimensions of texture image (from file)


};

//----------------------------------------------------------------------------

// sprite texture is array of num_cols x num_rows "frames" in single texture image 

class MultiSprite : public Sprite
{
public:

  MultiSprite(int, int, int);

  void draw(int, int, float, float, float, float, float, float = 1.0, float = 1.0, float = 1.0);

  int num_cols, num_rows;         // arrangement of frame subimages within larger image
  float sd, td;                   // width, height of each frame subimage in texture coordinates

};

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#endif
